/**
 * CLASS: LaserBox
 * AUTHOR: danpost (greenfoot username)
 * CREATED: January 27, 2017
 * 
 * DESCRIPTION: an object that emits a laser beam (Beam object); user-controlled using spacebar;
 */
import greenfoot.*;

public class LaserBox extends Actor
{
    Beam mainBeam; // the beam produced by this laser
    int freq = 0, timer = 0;
    
    /** creates the image and sets rotation of this laser */
    public LaserBox(int rotation)
    {
        GreenfootImage image = new GreenfootImage(30, 30);
        image.setColor(Color.LIGHT_GRAY);
        image.fill();
        image.setColor(Color.RED);
        image.fillRect(5, 5, 20, 20);
        image.setColor(Color.GRAY);
        image.fillRect(15, 11, 15, 8);
        Color trans = new Color(0, 0, 0, 0);
        for (int i=0; i<3; i++) for (int j=0; j<12; j++) image.setColorAt(18+j, 14+i, trans);
        setImage(image);
        setRotation(rotation);
    }
    
    /** controls the on/off state of the laser */
    public void act()
    {
        if (timer == 0)
        {
            if ((mainBeam == null) == Greenfoot.isKeyDown("space")) switchBeamState();
        }
        else if (--timer == 0)
        {
            switchBeamState();
            timer = freq;
        }
    }
    
    /** internal method used to turn the beam on and off */
    private void switchBeamState()
    {
        if (mainBeam == null) // switching on
        {
            mainBeam = new Beam(this);
            getWorld().addObject(mainBeam, getX(), getY());
            mainBeam.move(15);
        }    
        else // switching off
        {
            mainBeam.cutOffSource(this);
            mainBeam = null;
        }
    }
}